/* KEYTABLE.CPP */
/* Copyright Dave Curtis 1991 */
#include "keytable.hpp"
#include "dcerror.hpp"
#include <string.h>
#ifdef DB
#include <mem.h>
#endif

keytable::keytable(int mh,int mw) : table(mh,mw)
{
if ((people=new tab_person[MAX_KEY_DIAGS])==0)
  dcerror(ENOMEM,"Out of memory in keytable::keytable()");
}

keytable::~keytable()
{
clear();
// must do this now, otherwise will be called by table()
// and deleted people will be cleared
#if 0
people && delete [MAX_KEY_DIAGS] people;
#else
if (people) delete [] people;
#endif
}

void string_symbol::draw(gr_table_output_device *dev)
{
dev->print(string,0);
// fg_puts(FG_WHITE,FG_MODE_SET,~0,FG_ROT0,curr_x,curr_y+(sq_h-fg_box_height(fg.charbox))/2,str,screen.box);
}

string_symbol::~string_symbol() { if (string) free(string); }

keytable::input(data_file &f)
{
int i;
char line[121],string[81];
if (!f.fgets(line,121))
  { dcerror(1,"Could not read first line of key file"); return 0; }
symbol* p;
char *s;
if (!atoi(line))
  {
  sscanf(line,"%[^\n]",string);
  if ((s=strdup(string))==0)
     return dcerror(ENOMEM,"Out of memory in keytable::input()");
  p=new string_symbol(s);
  if (p==0)
     return dcerror(ENOMEM,"Out of memory in keytable::input()");
  item[0][2]=p;
  if (!f.fgets(line,121))
    return dcerror(2,"Could not read second line of key file");
  }
i=0;
person_ptr *pp;
do
{
int d;
++hi_gen;
if (sscanf(line,"%d %[^\n]",&d,string)!=2)
   { dcerror(3,"Bad key line format: %s",line); return 0; }
  people[i].set_diag(d);
  if ((s=strdup(string))==0)
     return dcerror(ENOMEM,"Out of memory in keytable::input()");
  p=new string_symbol(s);
  if (p==0)
     return dcerror(ENOMEM,"Out of memory in keytable::input()");
  pp=new person_ptr(&people[i]);
  if (pp==0)
     return dcerror(ENOMEM,"Out of memory in keytable::input()");
  item[hi_gen*2][0]=pp;
  item[hi_gen*2][2]=p;
  ++i;
} while (f.fgets(line,121) && *line!='\n' && i<11);
max_posy=3;
return 1;
}


