#include "pedlink.hpp"
#include "dcerror.hpp"
#include <ctype.h>
#include <string.h>

#define MAXCOND 20

static int fill_alls(char *alls_used,char *used_here,char *alls)
{
int i;
for (i=0;i<2;++i)
  {
  char *ptr;
  if (!isalnum(alls[i]) || alls[i]=='0') break;
  if ((strchr(alls_used,alls[i]))==0)
     { *(ptr=strchr(alls_used,'\0'))=alls[i]; * ++ptr='\0'; }
  if ((ptr=strchr(used_here,alls[i]))==0)
     {
     if (strlen(used_here)>=4) return 0;
     else
       { *(ptr=strchr(used_here,'\0'))=alls[i]; * ++ptr='\0'; }
     }
  }
return 1;
}

int linksys_pedigree::condense(int l,int towhat,data_file *fkey)
{
int i,j,k,m;
char alls_used[MAXCOND];
*alls_used='\0';
linksys_person *flsptr,*mlsptr;
if (have_condensed[l]) return 1;
int together[MAXCOND][MAXCOND],tot_m[MAXCOND],tot_k[MAXCOND];
for (i=0;i<MAXCOND;++i)
  for (j=0;j<MAXCOND;++j)
    together[i][j]=0;
for (i=0;i<count;++i)
  {
  flsptr=member(i);
  if (flsptr->gender!='M' || flsptr->numspo==0) continue;
  for (j=0;j<flsptr->numspo;++j)
    {
    char used_here[5];
    *used_here='\0';
    if (!fill_alls(alls_used,used_here,
      l<flsptr->nloci?flsptr->locphen[l].phen:""))
        return 0;
    mlsptr=(linksys_person*)flsptr->get_spouse(j);
    if (!fill_alls(alls_used,used_here,
      l<mlsptr->nloci?mlsptr->locphen[l].phen:""))
        return 0;
    mating *ma=flsptr->get_mating(j);
    for (m=0;m<ma->get_numch();++m)
         if (!fill_alls(alls_used,used_here,
           l<((linksys_person*)ma->get_child(m))->nloci?
             ((linksys_person*)ma->get_child(m))->locphen[l].phen:""))
             return dcerror(1,"Too many alleles in marriage between %s and %s",
                  (char*)flsptr->id,(char*)mlsptr->id);
    for (k=0;k<strlen(used_here);++k)
        {
        int kpos,mpos;
        kpos=strchr(alls_used,used_here[k])-alls_used;
        for (m=k+1;m<strlen(used_here);++m)
           {
           mpos=strchr(alls_used,used_here[m])-alls_used;
           ++together[kpos][mpos];
           ++together[mpos][kpos];
           }
        }
     }
    }
char key[MAXCOND][10];
for (i=0;i<strlen(alls_used);++i)
   {
   key[i][0]=key[i][1]=alls_used[i];
   key[i][2]='\0';
   }
char shortened[MAXCOND];
strcpy(shortened,alls_used);
while (strlen(shortened)>towhat)
  {
  int minm,mink,min_meet;
  min_meet=1000;
  mink=minm=0;
  for (k=0;k<strlen(shortened);++k)
     tot_m[k]=tot_k[k]=0;
  for (k=0;k<strlen(shortened);++k)
    for (m=k+1;m<strlen(shortened);++m)
        {
        tot_m[m]+=together[k][m];
        tot_k[k]+=together[k][m];
        if (together[k][m]<min_meet)
          {
          min_meet=together[k][m];
          mink=k;
          minm=m;
          }
        }
  if (tot_m[minm]>tot_k[mink])
    { m=minm; minm=mink; mink=m; } // recode least used allele
  char old_key=key[strchr(alls_used,shortened[minm])-alls_used][0];
  for (m=0;m<strlen(alls_used);++m)
    if (key[m][1]==old_key) key[m][1]=shortened[mink];
    // this deals not only with present allele, but those recoded to it
  for (m=0;m<strlen(shortened);++m)
    {
    together[mink][m]+=together[minm][m];
    together[m][mink]+=together[m][minm];
    }
  for (m=minm;m<strlen(shortened);++m)
    for (k=0;k<strlen(shortened);++k)
      together[m][k]=together[m+1][k];
  for (m=minm;m<strlen(shortened);++m)
    for (k=0;k<strlen(shortened-1);++k)
      together[k][m]=together[k][m+1];
  char *ptr=shortened+minm;
  while ((*ptr = *(ptr+1)) != '\0') ++ptr;
  }
for (i=0;i<count;++i)
  {
  flsptr=member(i);
  if (l>=flsptr->nloci||strlen(flsptr->locphen[l].phen)==8) continue;
  for (j=strlen(flsptr->locphen[l].phen);j<8;++j)
    flsptr->locphen[l].phen[j]=' ';
  flsptr->locphen[l].phen[8]='\0';
  for (j=0;j<2;++j)
   if (isalnum(flsptr->locphen[l].phen[j]) && flsptr->locphen[l].phen[j]!='0')
    flsptr->locphen[l].phen[6+j]='1'+
      strchr(shortened,
        key[strchr(alls_used,flsptr->locphen[l].phen[j])-alls_used][1])-shortened;
  }
if (fkey)
  {
  fkey->fprintf("ped %s\n",fam_name);
  for (i=0;i<strlen(alls_used);++i)
    fkey->fprintf("%c -> %c\n",alls_used[i],
      '1'+strchr(shortened,key[i][1])-shortened);
  fkey->fprintf("\n");
  }
have_condensed[l]=1;
return 1;
}

