/* PEDEDIT.CPP */
/* Copyright Dave Curtis 1991 */
#include "pededit.hpp"
// #include <datafile.hpp>
#include <dcerror.hpp>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#ifndef using_wx
#include <dos.h>
#endif

#ifndef max
#define max(x,y) ((x)>(y)?(x):(y))
#define min(x,y) ((x)<(y)?(x):(y))
#endif

static char line_no[ROWS][4];

#ifndef using_wx
editable_tab_person::editable_tab_person(dcwindow_set *ws,int r1,int c1,int r2,int c2,int np,int att,int fr,int fratt,void (*hf)(char*,...))
  : db_editor(ws,"Edit subject record",r1,c1,r2,c2,np,att,fr,fratt,hf)
#else
editable_tab_person::editable_tab_person(wxFrame **p,int r1,int c1,int r2,int c2,int np)
  : db_editor(p,"Edit subject record",r1,c1,r2,c2,np)
#endif
{
fieldlist<<new dcstring_field(1,1,"ID         : ",&id,MAXSTR);
fieldlist<<new char_field(2,1,"Gender: ",&gender);
fieldlist<<new int_field(2,20,"Diagnosis: ",&diag,3,0,109);
fieldlist<<new dcstring_field(3,1,"Father's ID: ",&fid,MAXSTR);
fieldlist<<new dcstring_field(4,1,"Mother's ID: ",&mid,MAXSTR);
fieldlist<<new strdup_field(5,1,"Text inset in symbol: ",&inset_str,MAXSTR);
fieldlist<<new edit_field(6,1,"Text lines (line 1 is ID):",0,0);
for (int i=0;i<ROWS;++i)
  {
  sprintf(line_no[i],"%2d ",i+2);
  fieldlist<<new strdup_field(7+i,1,line_no[i],&lines[i],MAXSTR);
  }
}

editable_pedparms::copy_in(void *s)
{
pedparms *source=(pedparms *)s;
pedparms::operator=(*source);
return 1;
}

editable_pedparms::copy_out(void *s)
{
pedparms *source=(pedparms *)s;
*source=*this;
return 1;
}

int tab_person::revise(editable_tab_person &tp_ed)
{
#ifndef using_wx
int rv;
if ((rv=tp_ed.do_editing(this))!=0)
  {
  tp_ed.modify(DISP_REVERSEVIDEO,0);
  bioskey(0);
  tp_ed.modify(DISP_NORMAL,0);
  }
tp_ed.suspend();
return rv;
#else
return tp_ed.do_editing(this);
#endif
}

editable_tab_person::copy_in(void *source)
{
tab_person::operator=(*(tab_person*)source);
return 1;
}

editable_tab_person::copy_out(void *source)
{
void *s=this;
*(tab_person*)source=*this;
return 1;
}


pedparms::save(char *fn,char *ver)
{
data_file file;
if (!file.open(fn,"wb")) return 0;
if (fwrite(ver,strlen(ver),1,get_fp(file))!=1 ||
    fwrite(this,sizeof(pedparms),1,get_fp(file))!=1
    || (!save_file.is_null() && !save_file.save(get_fp(file)))
    || (!input_file_name.is_null() && !input_file_name.save(get_fp(file))))
   return dcerror(1,"Error writing file %s",fn);
else return 1;
}

pedparms::load(char *fn,char *ver)
{
data_file file;
char v[10];
pedparms oldparms;
int len;
if (!file.open(fn,"rb")) return 0;
if (fread(v,strlen(ver),1,get_fp(file))!=1)
   return dcerror(1,"Error reading file %s",fn);
else if (strncmp(v,ver,strlen(ver)))
   return dcerror(2,"%s is not correct for this version of PEDRAW",fn);
oldparms=*this;
save_file.strfree();
if (fread(this,sizeof(pedparms),1,get_fp(file))!=1
    || (!save_file.is_null() && (save_file.set_null(),!save_file.load(get_fp(file))))
    || (!input_file_name.is_null() && (input_file_name.set_null(),!input_file_name.load(get_fp(file)))))
   {
   *this=oldparms;
   return dcerror(1,"Error reading file %s",fn);
   }
else
  {
  editable_pedparms pp_ed;
  pp_ed.copy_in(this);
  if (pp_ed.check())
     {
     *this=oldparms;
     return dcerror(1,"Bad data in %s",fn);
     }
  else return 1;
  }
}

pedparms::pedparms()
{
char buffer[40];
extend=no_diag=unsex=0;
inset=1;
gen_to_print=6;
sym_h=24;
sym_w=24;
gap_h=16;
gap_w=16;
border_h=border_w=8;
max_gen=MAXGEN;
max_wid=MAXWID;
extra_line_h=12;
save_file=0;
*t_line_str=*title_str='\0';
for (int i=0;i<min(5,ROWS+1);++i)
  { t_lines[i]=1; sprintf(strchr(t_line_str,'\0'),"%s%d",i?",":"",i+1); }
ps_x_scale=ps_y_scale=1.0;
ps_x_trans=ps_y_trans=0.0;
ps_landscape=1;
default_output_type='P';
}

pedparms::~pedparms()
{
; // if (save_file) free(save_file); if (input_file_name) free(input_file_name);
}

pedparms& pedparms::operator=(const pedparms &old)
{
save_file.strfree();
memcpy(this,&old,sizeof(old));
save_file.set_null();
if (!save_file.assign(old.save_file))
     dcerror(ENOMEM,"Out of memory in pedparms::operator=()");
if (!input_file_name.assign(old.input_file_name))
     dcerror(ENOMEM,"Out of memory in pedparms::operator=()");
#if 0
inset=old.inset;
max_wid=old.max_wid;
max_gen=old.max_gen;
batch=old.batch;
extend=old.extend;
no_diag=old.no_diag;
pict=old.pict;
unsex=old.unsex;
invisible=old.invisible;
gen_to_print=old.gen_to_print;
save_file && free(save_file),save_file=0;
if (old.save_file)
  {
  if ((save_file=strdup(old.save_file))==0)
     dcerror(ENOMEM,"Out of memory in pedparms::operator=()");
  }
strcpy(title_str,old.title_str);
sym_h=old.sym_h;
sym_w=old.sym_w;
gap_h=old.gap_h;
gap_w=old.gap_w;
extra_line_h=old.extra_line_h;
for (int i=0;i<ROWS+1;++i)
    t_lines[i]=old.t_lines[i];
strcpy(t_line_str,old.t_line_str);
#endif
return *this;
}

#ifndef using_wx
editable_pedparms::editable_pedparms(dcwindow_set *ws,int r1,int c1,int r2,int c2,int np,int att,int fr,int fratt,void (*hf)(char *form,...))
  : db_editor(ws,"Edit parameters",r1,c1,r2,c2,np,att,fr,fratt,hf)
#else
editable_pedparms::editable_pedparms(wxFrame **p,int r1,int c1,int r2,int c2,int np)
  : db_editor(p,"Edit parameters",r1,c1,r2,c2,np)
#endif
{
fieldlist<<new yn_field(1,1,"Conceal sex ",&unsex);
fieldlist<<new yn_field(1,30,"Conceal diagnosis ",&no_diag);
fieldlist<<new dcstring_field(2,1,"File name for saved diagram ",&save_file,20,120);
fieldlist<<new strdup_field(3,1,"(Leave blank for default) ",0,0);
fieldlist<<new edit_field(4,1,"Title ",pedparms::title_str,50);
fieldlist<<new edit_field(5,1,"Numbers of lines to show ",t_line_str,40);
fieldlist<<new yn_field(6,1,"Show text inset in symbol ",&inset);
fieldlist<<new short_field(7,1,"Symbol height     ",&sym_h,3,4,200);
fieldlist<<new short_field(7,30,"Symbol width    ",&sym_w,3,4,200);
fieldlist<<new short_field(8,1,"Gap height        ",&gap_h,3,4,200);
fieldlist<<new short_field(8,30,"Gap width       ",&gap_w,3,4,200);
fieldlist<<new short_field(9,1,"Extra line height ",&extra_line_h,3,4,200);
fieldlist<<new short_field(10,1,"Generations to print ",&gen_to_print,3,2,200);
fieldlist<<new yn_field(10,30,"Show all members ",&extend);
fieldlist<<new short_field(11,1,"Max generations  ",&max_gen,3,1,200);
fieldlist<<new short_field(11,30,"Max columns      ",&max_wid,4,1,5000);
fieldlist<<new short_field(12,1,"Border height        ",&border_h,3,0,200);
fieldlist<<new short_field(12,30,"Border width       ",&border_w,3,0,200);
#ifndef wx_msw
fieldlist<<new char_field(13,1,"Default output type (PXS)",&default_output_type);
fieldlist<<new strdup_field(14,1,"(Postscript/Xbm/Screen)",0,0);
#else
fieldlist<<new char_field(13,1,"Default output type (PBIS)",&default_output_type);
fieldlist<<new strdup_field(14,1,"(Postscript/BMP/prInter/Screen)",0,0);
#endif
fieldlist<<new strdup_field(16,1,"Postscript settings:",0,0);
fieldlist<<new double_field(17,1,"X scale  ",&ps_x_scale,6);
fieldlist<<new double_field(17,30,"Y scale  ",&ps_y_scale,6);
fieldlist<<new double_field(18,1,"X translation  ",&ps_x_trans,6);
fieldlist<<new double_field(18,30,"Y translation  ",&ps_y_trans,6);
fieldlist<<new yn_field(19,1,"Landscape orientation ",&ps_landscape);
}

int pedparms::revise(editable_pedparms& parmed)
{
#ifndef using_wx
int rv;
if ((rv=parmed.do_editing(this))!=0)
  {
  parmed.modify(DISP_REVERSEVIDEO,0);
  bioskey(0);
  parmed.modify(DISP_NORMAL,0);
  }
parmed.suspend();
return rv;
#else
return parmed.do_editing(this);
#endif
}

int editable_pedparms::check()
{
char buffer[81];
int i;
if (save_file)
   {
   buffer[0]='\0';
   if (sscanf(save_file," %s ",buffer)!=1)
      free(save_file), save_file=0;
   else strcpy(save_file,buffer);
   }
for (i=0;i<ROWS+1;++i)
  t_lines[i]=0;
char *ptr=strtok(t_line_str,",");
if (ptr) do
  {
  int c=atoi(ptr);
  if (!c) continue;
  if (c<1 || c>ROWS+1)
    { sprintf(buffer,"Only %d lines",ROWS+1); explain(buffer); return 6; }
  else t_lines[c-1]=1;
  } while ((ptr=strtok(0,","))!=0);
t_line_str[0]='\0';
for (i=0;i<ROWS+1;++i)
  if (t_lines[i])
     sprintf(strchr(t_line_str,'\0'),"%s%d",*t_line_str?",":"",i+1);
if (isalpha(default_output_type)) default_output_type=toupper(default_output_type);
if (!strchr(LEGAL_OUTPUT_TYPES,default_output_type))
  { explain("Output type must be one of " LEGAL_OUTPUT_TYPES); return 19; }
return 0;
}


int editable_tab_person::check()
{
char buff1[21],buff2[21];
if (id.is_null() || sscanf(id," %20s %20s",buff1,buff2)!=1)
  { explain("Must have ID with no embedded blanks"); return 1; }
else strcpy(id,buff1);
gender=toupper(gender);
if (gender!='M' && gender!='F' && gender!='X')
  { explain("Gender must be M, F or X"); return 2; }
#if 0
if (diag%100>9)
  { explain("Diagnosis must be 0-9 (plus 100 if dead)"); return 3; }
#endif
*buff1='\0';
if (!fid.is_null() && sscanf(fid," %20s %20s",buff1,buff2)==2)
  { explain("Must have no blanks in father's ID"); return 4; }
else
  if (*buff1) fid=buff1;
  else fid.strfree(); // just blanks
*buff1='\0';
if (mid && sscanf(mid," %20s %20s",buff1,buff2)==2)
  { explain("Must have no blanks in mother's ID"); return 5; }
else
  if (*buff1) mid=buff1;
  else mid.strfree(); // just blanks
if (fid.is_null() != mid.is_null())
  { explain("Cannot have just one parent's ID"); return 4; }
return 0;
}


