#include "pedtable.hpp"
#include "dcerror.hpp"

int tab_person::ged_input(data_file& file)
{
char line[241],buff1[100],buff2[100],buff3[100],*ptr;
int c;
do    {					 // read in initial blank or bad lines
      *buff1='\0';
      if (feof(get_fp(file)) || !fgets(line,240,get_fp(file)))
         return 0;
      if (sscanf(line," %s %s %s",buff1,buff2,buff3)!=3) continue;
      } while (strcmp(buff1,"0") || strcmp(buff3,"INDI"));
if (strchr(buff2+1,'@')) *strchr(buff2+1,'@')='\0'; // lose second @ first
if (!id.assign((*buff2=='@')?buff2+1:buff2)) // now lose first @
  return dcerror(ENOMEM,"Out of memory in tab_person::ged_input()");
while ((c=fgetc(get_fp(file)))!='0' && c!=EOF)
  {
  ungetc(c,get_fp(file));
  fgets(line,240,get_fp(file));
  c=sscanf(line," %s %s %[^\n]",buff1,buff2,buff3);
  if (c==3 && !strcmp(buff1,"1") && !strcmp(buff2,"SEX"))
    gender=toupper(*buff3);
  if (gender!='M'&&gender!='F'&&gender!='X')
    dcerror(23,"Bad gender : %c in %s",gender,(char*)id);
  if (c==3 && !strcmp(buff1,"1") && !strcmp(buff2,"NAME"))
    {
    while ((ptr=strchr(buff3,'/'))!=0) *ptr=' ';
    for (c=0;*buff2='\0',sscanf(buff3,"%s %[^\n]",buff1,buff2)>=1;c++)
      {
      strcpy(buff3,buff2);
      if ((lines[c]=strdup(buff1))==0)
        return dcerror(ENOMEM,"Out of memory in tab_person::ged_input()");
      }
    }
  }
if (c!=EOF) ungetc(c,get_fp(file));
return 1;
}

int tab_pedigree::read_ged_fams(data_file& file)
{
char line[241],buff1[100],buff2[100],buff3[100],*ptr,fstr[MAXSTR+1],mstr[MAXSTR+1],chstr[MAXSTR+1];
tab_person *child;
int c;
while (1)
{
do    {					 // read in initial blank or bad lines
      *buff1='\0';
      if (!file.fgets(line))
         return 1;
      if (sscanf(line," %s %s %s",buff1,buff2,buff3)!=3) continue;
      } while (strcmp(buff1,"0") || strcmp(buff3,"FAM"));
while ((c=file.fgetc())!='0' && c!=EOF)
  {
  file.ungetc(c);
  file.fgets(line);
  c=sscanf(line," %s %s %[^\n]",buff1,buff2,buff3);
  if (c==3 && !strcmp(buff1,"1") && !strcmp(buff2,"HUSB"))
    {
    if (strchr(buff3+1,'@')) *strchr(buff3+1,'@')='\0'; // lose second @ first
    strncpy(fstr,(*buff3=='@')?buff3+1:buff3,MAXSTR); // now lose first @
    fstr[MAXSTR]='\0';
    }
  if (c==3 && !strcmp(buff1,"1") && !strcmp(buff2,"WIFE"))
    {
    if (strchr(buff3+1,'@')) *strchr(buff3+1,'@')='\0'; // lose second @ first
    strncpy(mstr,(*buff3=='@')?buff3+1:buff3,MAXSTR); // now lose first @
    mstr[MAXSTR]='\0';
    }
  if (c==3 && !strcmp(buff1,"1") && !strcmp(buff2,"CHIL"))
    {
    if (strchr(buff3+1,'@')) *strchr(buff3+1,'@')='\0'; // lose second @ first
    strncpy(chstr,(*buff3=='@')?buff3+1:buff3,MAXSTR); // now lose first @
    chstr[MAXSTR]='\0';
    c=which(chstr);
    child=(tab_person*)get_anc(c);
    if (!child->fid.assign(fstr) || !child->mid.assign(mstr))
     return dcerror(ENOMEM,"Out of memory in tab_pedigree::read_ged_fams()");
    }
  }
if (c!=EOF) file.ungetc(c);
else return 1;
}
}
