/* PEDOUT.CPP */
/* Copyright Dave Curtis 1991 */
#include "pedtable.hpp"
#include <math.h>
#include <string.h>
#ifdef MDB
#include <mem.h>
#endif

#ifndef max
#define max(x,y) ((x)>(y)?(x):(y))
#define min(x,y) ((x)<(y)?(x):(y))
#endif

table_output_device::table_output_device(int us,int nd)
{ unsex=us; no_diag=nd; }

table_output_device::output(table& tab,int forkey)
{
int ns=get_no_sections(tab,forkey);
for (int s=0;s<ns;++s)
  {
  set_section(s,tab,forkey);
  for (row=minr;row<=maxr;row+=rinc)
    for (col=minc;col<=maxc;col+=cinc)
      draw_item(tab,row,col);
  output_section(s,tab);
  }
finish_output();
return ns;
}

table_output_device::finish_output()
{
return 1;
}

table_output_device::save() { return 1; }

table_output_device::~table_output_device() {;}

tre_file::output_section(int s,table &tab)
{
if (title)
   {
   fp && fprintf(fp,"%s\n",title);
//   printf("%s\n",title);
   }
for (int i=0;i<lines_done;++i)
   {
   fp && fprintf(fp,"%s\n",buffer[i]);
//   printf("%79.79s\n",buffer[i]);
   }
return 1;
}


tre_file::set_section(int s,table& tab,int forkey)
{
lines_done=0;
minr=0;
maxr=min(gen_to_print,tab.get_hi_gen())*2;
rinc=1;
maxc=minc=tab.get_max_posy()-s;
cinc=1;
for (int i=0;i<ROWS+1;++i) buffer[i][0]='\0';
if (s==0) title=tab.get_title();
else title=0;
return 1;
}

void tre_file::draw_item(table& tab,int r, int c)
{
char s[30];
for (int l=0;l<tab.ntlines(r,c);++l)
  {
  tab.print(s,r,c,l);
  strcat(buffer[l],s);
  }
lines_done=l;
}

tre_file::tre_file(char *fn,int gens)
{
gen_to_print=gens;
fp=fopen(fn,"w");
// fp && epson && fprintf(fp,"\033t\01\033" "6\n");
}

tre_file::~tre_file() { fp && fclose(fp); }

tre_file::get_no_sections(table& tab,int forkey)
{
return tab.get_max_posy()+1;
}


