/* PEDOUT.HPP */
/* Copyright Dave Curtis 1991 */
#ifndef PEDOUTHPP
#define PEDOUTHPP 1

#include <stdio.h>

#define GAPCOL 1
#define MGAPCOL 0
#define MSCOL  0   /* middle of person symbol, must be 0 in case only 1 line*/
#define GAPROW 3   /* between rows of sibs */
#define MGAPROW 1

class table;

class table_output_device
{
virtual finish_output();
virtual output_section(int s,table& tab)=0;
virtual get_no_sections(table& tab,int forkey)=0;
virtual set_section(int s,table& tab,int forkey)=0;
virtual void draw_item(table& tab,int r,int c)=0;
protected:
int row,col,minr,minc,maxr,maxc,rinc,cinc;
char *title;
public:
virtual int save();
table_output_device(int us=0,int nd=0);
char unsex,no_diag;
virtual ~table_output_device();
output(table& tab,int forkey=0);
};

class gr_table_output_device : public table_output_device
{
public:
virtual void draw(float x1,float y1,float x2,float y2,int col=1)=0; //draw lines in unit box
// virtual shade_square(int shade)=0; belongs to msp_tre_file
virtual void draw_square(int shade,char *inset)=0;
virtual void draw_circle(int shade,char *inset)=0;
// virtual draw_triangle(int shade)=0;
virtual void draw_diamond(int shade,char *inset)=0;
virtual void draw_loopable_line()=0;
virtual void print(char *s,int l)=0;
//virtual ~gr_table_output_device()=0;
char inset;
gr_table_output_device(int us=0,int nd=0,int i=1)
  : table_output_device(us,nd)
  { inset=i; }
};

#define ROWS 10  /* same as in pedigree.hpp */

class tre_file : public table_output_device
{
char buffer[ROWS+1][241];
int gen_to_print;
FILE *fp;
int lines_done;
virtual get_no_sections(table& tab,int forkey);
virtual set_section(int s,table& tab,int forkey);
virtual output_section(int s,table& tab);
virtual void draw_item(table& tab,int r, int c);
public:
tre_file(char *fn,int gens=5);
~tre_file();
};
#undef ROWS

#endif

