/* PEDRAW.CPP */
/* Copyright Dave Curtis 1991 */
#include "pedlink.hpp"
#include "pedraw.hpp"
#include "pedwxdc.hpp"


#include <string.h>
#ifndef using_wx
#include <bios.h>
#endif
//#include <fg.h>
#include <dcerror.hpp>
#ifdef MDB
#include <mem.h>
#endif
#include "keytable.hpp"

extern int choose_file(char *s,char *prompt=0,char *supplied_spec=0);

sortkey(int output_type)
{
static char keyfrom[65],keyto[65];
keytable kt;
data_file df;
prompt("Select the file to read the key data from");
if (choose_file(keyfrom) && df.open(keyfrom,"r") && kt.input(df) && !dcerror.stat()
   && (prompt("Will read data from %s\nSelect the file to write the key to",keyfrom),
    choose_file(keyto)))
   return draw_ped(kt,strcmp(keyto,"0")?keyto:"",1,output_type);
else return 0;
}

int savefile(char *s,tab_pedigree &ped)
{
data_file file;
if (file.open(s,"w")) ped.save(file);
return !dcerror.stat();
}

Bool wxSaveBitmapToGif(char *filename, wxBitmap *bitmap);

draw_ped(table &tab,char *fn,int forkey,int output_type)
{
dcerror.clear();
table_output_device *outfile=0;
for (int i=0;i<ROWS+1;++i)
   tab.set_t_line(i,forkey?0:pparms.t_lines[i]);
if (!forkey) tab.set_title(pparms.title_str);
else tab.set_title(0);
wxMemoryDC sharedDC;
ped_canvas *pc;
switch (output_type)
  {
   case PED_TEXT:
        outfile=new tre_file(fn,pparms.gen_to_print);
        outfile->output(tab,forkey);
        if (!dcerror.stat()) outfile->save();
        delete (outfile);
        break;
   case PED_CANVAS:
           pc=new ped_canvas(mainframeptr,
           forkey?12:pparms.gen_to_print,&pparms,fn);
           pc->drawer.output(tab,forkey);
           pc->display();
           break; // don't delete frame under msw
   case PED_BMP:
   case PED_XPM:
#ifdef wx_msw
#if ! USE_IMAGE_LOADING_IN_MSW
dcerror(1,"Cannot write bitmaps because program was compiled without USE_IMAGE_LOADING_IN_MSW");
break;
#endif
#else
#if ! USE_IMAGE_LOADING_IN_X
dcerror(1,"Cannot write bitmaps because program was compiled without USE_IMAGE_LOADING_IN_X");
break;
#endif
#endif
   case PED_GIF: // not available yet
          wxmem_tre_file *bitmap;
          bitmap=new wxmem_tre_file(&sharedDC,
           forkey?12:pparms.gen_to_print,&pparms);
          if (bitmap)
            {
            bitmap->output(tab,forkey);
            bitmap->buffer->SaveFile(fn,
                (output_type==PED_BMP)?wxBITMAP_TYPE_BMP:
                (output_type==PED_XPM)?wxBITMAP_TYPE_XPM:wxBITMAP_TYPE_GIF,0);
            delete bitmap;
            }
          break;
#ifdef wx_msw
    case PED_PRINT:
#endif
    case PED_PS:
    wxDC *dc;
if (output_type==PED_PS)
  {
  wxSetPrinterOrientation(pparms.ps_landscape?PS_LANDSCAPE:PS_PORTRAIT);
  wxSetPrinterScaling(pparms.ps_x_scale,pparms.ps_y_scale);
  wxSetPrinterTranslation(pparms.ps_x_trans,pparms.ps_y_trans);
  wxSetPrinterMode(PS_FILE); // always set this, not controlled by user
  }
#ifdef wx_msw
    if (output_type==PED_PRINT)
       {
       dc=new wxPrinterDC(NULL,NULL,NULL,input_file==0);
       dc->SetMapMode(MM_POINTS);
       }
    else
#endif
       dc=new wxPostScriptDC(fn,input_file==0);
    if (dc && dc->Ok())
      {
      wx_tre_file *printer;
      printer=new wx_tre_file(dc,
           forkey?12:pparms.gen_to_print,
           &pparms);
      if (printer)
        {
        dc->StartDoc("Hello printout");
        dc->StartPage();
        printer->output(tab,forkey);
        delete printer;
        dc->EndPage();
        dc->EndDoc();
if (output_type==PED_PS)
  {
  float x,y;
  pparms.ps_landscape=(wxGetPrinterOrientation()==PS_LANDSCAPE);
  wxGetPrinterScaling(&x,&y);
  pparms.ps_x_scale=x; pparms.ps_y_scale=y;
  wxGetPrinterTranslation(&x,&y);
  pparms.ps_x_trans=x; pparms.ps_y_trans=y;
  }
        }
      delete dc;
      }
      break;
   }
return 1;
}



