/* PEDSORT.CPP */
/* Copyright Dave Curtis 1991 */
#include "pedtable.hpp"
#include <dcerror.hpp>
#ifdef MDB
#include <mem.h>
#endif

#ifndef max
#define max(x,y) ((x)>(y)?(x):(y))
#define min(x,y) ((x)<(y)?(x):(y))
#endif

table::add_extra_line(int l,int at_top)
{
// _chkstack();
TABLE_ROW newrow=new PTABLE_ITEM[max_w];
//PTABLE_ROW pnewrow=&newrow;
if (at_top)
  extra_line[l].start();
else
  extra_line[l].end();
if (!newrow || extra_line[l].linkin(newrow))
   { dcerror(2,"No memory adding extra line"); return 0; }
else
   {
   for (int i=0;i<max_w;++i) newrow[i]=0;
   if (at_top) // swap first two
       {
       extra_line[l].start();
       newrow=extra_line[l].linkout();
       extra_line[l].linkin(newrow);
       extra_line[l].start();
       }
   return 1;
   }
}

table::sort_table_from(tab_person *anc,int extending)
{
extend=extending;
if (extend)
   anc=(tab_person*)anc->find_proband();
if (!get_seed(anc,0,0)) return 0;
ancs_to_do.start();
while (ancs_to_do.size())
  {
  tab_person *temp;
//  ancs_to_do.end();  // now last on first off
  temp=ancs_to_do.linkout();
//  ancs_to_do.end();
  if (extend && temp->get_draw_stat()==NOTDONE)
     if (!get_seed(temp,max_posy+2,0)) return 0;
  }
return 1;
}

int table::get_seed(tab_person *anc,int miny,int following)
{
// _chkstack();
int size,sp,i;
tab_person *test;
if (anc->gennum>=max_h/2)
   return dcerror(3,"Too few rows in table (%d)",max_h/2);
size=0;
int repeating=0;
int savgen,savy,was_loose=0;
if  (anc->get_draw_stat()!=NOTDONE)
   {
   repeating=1;
   anc->posy=-1;
   anc->set_draw_stat(REP);
   }
if (anc->posy==-1)
  {
  was_loose=1;
  if (miny>=max_w)
     return dcerror(3,"Too few columns in table (%d)",max_w/2);
  anc->posy=miny;
  if ((item[anc->gennum*2][anc->posy]=new person_ptr(anc))==0)
         return dcerror(ENOMEM,"Out of memory in table::get_seed()");
  if (repeating)
         item[anc->gennum*2][anc->posy]->draw_stat=REP;
  }
savgen=anc->gennum; savy=anc->posy;
if (!repeating)
 {
 anc->set_draw_stat(SEEDDONE);
 TABLE_ROW hi_row=0;
 which_marriage marriage;
 int marr_to_do=0,left;
 for (left=0;left<anc->get_numspo();++left)
//    if (((tab_person*)anc->get_spouse(left))->get_draw_stat()==NOTDONE)
    if (anc->get_mating(left)->get_stat()==NOTDONE)
      ++marr_to_do;
 marriage=(marr_to_do>1)?FIRST:ONLY;
 for (sp=0;sp<anc->get_numspo();++sp)
  {
//  if (((tab_person*)anc->get_spouse(sp))->get_draw_stat()==NOTDONE)
  if (anc->get_mating(sp)->get_stat()==NOTDONE)
    {
    if (marriage==FIRST)
      {
      add_extra_line(anc->gennum*2);
      hi_row=extra_line[anc->gennum*2].get();
      }
    int addsize;
    if ((addsize=get_couple_seed(anc,(tab_person*)anc->get_spouse(sp),miny+size,marriage,hi_row))
         ==0) return 0;
    size+=addsize;
    if (((tab_person*)anc->get_spouse(sp))->get_draw_stat()==NOTDONE)
      {
      if ((addsize=get_seed((tab_person*)anc->get_spouse(sp),miny+size,0))==0)
         return 0;
      size+=(addsize==2)?0:addsize;
      }
    for (marr_to_do=0,left=sp+1;left<anc->get_numspo();++left)
//      if (((tab_person*)anc->get_spouse(left))->get_draw_stat()==NOTDONE)
      if (anc->get_mating(left)->get_stat()==NOTDONE)
        ++marr_to_do;
    marriage=(marr_to_do>1)?MIDDLE:LAST;
    }
  }
 }
if (was_loose && item[savgen*2][savy+1])  // slide person along to meet first spouse
  {
  while (!item[savgen*2][savy+2] || !item[savgen*2][savy+2]->is_a_person())
    {
    if (item[savgen*2][savy+1])
      { delete item[savgen*2][savy+1]; item[savgen*2][savy+1]=0; }
    if (item[savgen*2][savy+2]) delete item[savgen*2][savy+2];
    item[savgen*2][savy+2]=item[savgen*2][savy];
    item[savgen*2][savy]=0;
    savy+=2;
    }
  }
anc->posy=savy;  // needed by parents
anc->gennum=savgen;  // in case gets another line drawn to it
max_posy=max(max_posy,anc->posy);
hi_gen=max(hi_gen,anc->gennum);
if (following) if ((item[savgen*2-1][savy]=new symbol_mid_sib)==0)
     return dcerror(ENOMEM,"Out of memory in table::get_seed()");
 //''
return anc->width=max(size,2);
}

tab_person *tab_person::set_new_anc()
{
tab_person *next;
if (!parents)
  return this;
#if 0
else next=(tab_person*)get_mother();
if (next->posy==-1)
  next->gennum=max(gennum-1,0);
return next->set_new_anc();
#endif
next=(tab_person*)find_proband();
if (next->posy==-1)
  next->gennum=max(gennum-1,0);
return next;
}

int table::do_child(tab_person *kid,int miny,int pargennum,int& chminy,int& chmaxy)
{
if (kid->get_draw_stat()==NOTDONE || kid->gennum<=pargennum)
    {
    kid->gennum=pargennum+1;
    int size=get_seed(kid,miny,1);
    if (chminy==-1) chminy=kid->posy;
    chmaxy=kid->posy;
    return size;
    }
else
   {
   int ydrop=miny;
   if (chminy==-1) chminy=ydrop;
   chmaxy=ydrop;
   max_posy=max(max_posy,chmaxy);
   if ((item[pargennum*2+1][ydrop]=new symbol_mid_sib)==0)
        return dcerror(ENOMEM,"Out of memory in table::do_child()");
   for (int g=pargennum*2+2;g<kid->gennum*2;++g)
     item[g][ydrop]=new symbol_above_child;
//   add_extra_line(g,1); // at top
   add_extra_line(g,0); // try if at end is better
   TABLE_ROW newline=extra_line[g].get();
   newline[ydrop--]=new symbol_only_child;
   while (ydrop>kid->posy) newline[ydrop--]=new symbol_between_sibs;
   newline[ydrop]=new symbol_first_sib;
   return 2;
   }
}

table::get_couple_seed(tab_person *par1,tab_person *par2,int miny,which_marriage marriage,TABLE_ROW hi_row)
{
int i,size,sp,ch,chminy,chmaxy;
int savgen,savgen2,savstat,savy;
mating *m;
size=0;
chmaxy=chminy=-1;
savy=par1->posy;
savgen2=par2->gennum;
savgen=par2->gennum=par1->gennum;
savstat=par2->get_draw_stat();
if (extend)
    {
    if ((par2->get_father() &&
        ((tab_person*)par2->get_father())->get_draw_stat()==NOTDONE) ||
        (par2->get_mother() &&
          ((tab_person*)par2->get_mother())->get_draw_stat()==NOTDONE))
       ancs_to_do.linkin(par2->set_new_anc());
    }
for (sp=0;sp<par1->get_numspo();++sp)
  if (par1->get_spouse(sp)==par2)
      {
      m=par1->get_mating(sp);
      m->set_stat(SEEDDONE);
      for (ch=0;ch<m->get_numch();++ch)
        {
        int adding;
        if ((adding=do_child((tab_person*)m->get_child(ch),miny+size,par1->gennum,chminy,chmaxy))
           ==0) return 0;
        size+=adding;
        }
      break;
      }
par1->gennum=par2->gennum=savgen;
par1->posy=savy;
// par2->set_draw_stat(savstat);
if (chminy==-1)         /* no children */
  {
  chminy=chmaxy=miny;
  if (marriage!=ONLY && marriage!=FIRST) par2->posy=chminy; /* Not first wife */
  else
    {
    par2->posy=chminy+2;
#if 0
// always set in get_seed()
    if (par1->posy==-1)
      {
      if (chminy>=max_w)
          return dcerror(3,"Too few columns in table (%d)",max_w/2);
      par1->posy=chminy;  /* set posy with first spouse found*/
      if ((item[par1->gennum*2][par1->posy]=new person_ptr(par1))==0)
            return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
      if (par1->get_draw_stat()==REP)
         item[par1->gennum*2][par1->posy]->draw_stat=REP;
      }
#endif
    }
  max_posy=max(max_posy,par2->posy);
  if (par2->posy>=max_w)
     return dcerror(3,"Too few columns in table (%d)",max_w/2);
  if ((item[par2->gennum*2][par2->posy]=new person_ptr(par2))==0)
        return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
  if (par2->get_draw_stat()!=NOTDONE)
     item[par2->gennum*2][par2->posy]->draw_stat=REP;
  item[par2->gennum*2][par2->posy-1]=
    marriage==ONLY?(PTABLE_ITEM)new symbol_only_marriage(0):
    marriage==FIRST?(PTABLE_ITEM)new symbol_first_marriage_lo_half(0):
    marriage==MIDDLE?(PTABLE_ITEM)new symbol_middle_marriage_lo_half(0):
                     (PTABLE_ITEM)new symbol_last_marriage_lo_half(0);
  if (item[par2->gennum*2][par2->posy-1]==0) return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
  if (hi_row) // not only marriage
    if ((hi_row[par2->posy-1]=
    marriage==FIRST?(PTABLE_ITEM)new symbol_first_marriage_hi_half:
    marriage==MIDDLE?(PTABLE_ITEM)new symbol_middle_marriage_hi_half:
                     (PTABLE_ITEM)new symbol_last_marriage_hi_half)
        ==0) return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
  }
else
 {
 if (chmaxy-chminy)
  {
  delete item[par2->gennum*2+1][chmaxy];  // midsib symbol
  if ((item[par2->gennum*2+1][chmaxy]=new symbol_last_sib)==0)
        return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
     //'';
  for (i=chmaxy-1;i>chminy;--i)
     if (!item[par2->gennum*2+1][i])
             if ((item[par2->gennum*2+1][i]=new symbol_between_sibs)==0)
                return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
      //'';
  delete item[par2->gennum*2+1][((chminy+chmaxy-2)/4)*2+1];
  if ((item[par2->gennum*2+1][((chminy+chmaxy-2)/4)*2+1]=new symbol_many_children)==0)
      return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
     // '')
  }
 else if ((item[par2->gennum*2+1][chminy+1]=new symbol_only_child)==0)
      return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
 //''
 delete item[par2->gennum*2+1][chminy];
 if ((item[par2->gennum*2+1][chminy]=new symbol_first_sib)==0)
     return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
 //''
 par2->posy=((chminy+chmaxy-2)/4)*2+2;
 par2->posy=max(par2->posy,chminy+2);
#if 0
//always set in get_seed()
 if (par1->posy==-1)
    {
    par1->posy=par2->posy-2;
    if (par1->posy>=max_w)
       return dcerror(3,"Too few columns in table (%d)",max_w/2);
    if ((item[par1->gennum*2][par1->posy]=new person_ptr(par1))==0)
          return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
    if (par1->get_draw_stat()==REP)
         item[par1->gennum*2][par1->posy]->draw_stat=REP;
    }
#endif
 max_posy=max(max_posy,par2->posy);
 if (par2->posy>=max_w)
     return dcerror(3,"Too few columns in table (%d)",max_w/2);
 item[par2->gennum*2][par2->posy]=new person_ptr(par2);
 if (par2->get_draw_stat()!=NOTDONE)
   item[par2->gennum*2][par2->posy]->draw_stat=REP;
 if ((item[par2->gennum*2][par2->posy-1]=
    marriage==ONLY?(PTABLE_ITEM)new symbol_only_marriage(1):
    marriage==FIRST?(PTABLE_ITEM)new symbol_first_marriage_lo_half(1):
    marriage==MIDDLE?(PTABLE_ITEM)new symbol_middle_marriage_lo_half(1):
                     (PTABLE_ITEM)new symbol_last_marriage_lo_half(1))
     ==0) return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
  if (hi_row) // not only marriage
    if ((hi_row[par2->posy-1]=
    marriage==FIRST?(PTABLE_ITEM)new symbol_first_marriage_hi_half:
    marriage==MIDDLE?(PTABLE_ITEM)new symbol_middle_marriage_hi_half:
                     new symbol_last_marriage_hi_half)
       ==0) return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
 }
if (marriage!=FIRST && marriage!=ONLY)
  {
  for (i=par2->posy-2;!hi_row[i];--i)
         if ((hi_row[i]=new symbol_between_spouses_hi_half)==0)
          return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
  }
else if (par1->posy!=-1) // never is
  for (i=par2->posy-2;i>par1->posy && !item[par2->gennum*2][i];--i)
      if ((item[par2->gennum*2][i]=new symbol_between_spouses_lo_half)==0)
          return dcerror(ENOMEM,"Out of memory in table::get_couple_seed()");
if (savstat!=NOTDONE) par2->gennum=savgen2;
return par2->width=max(size,4);
}


