/* PEDWXDC.CXX */
/* Copyright Dave Curtis 1996 */
#include "pedwxdc.hpp"
#include "pedtable.hpp"
#include "dcerror.hpp"
#include <string.h>
#include <stdlib.h>

#ifndef max
#define max(x,y) ((x)>(y)?(x):(y))
#define min(x,y) ((x)<(y)?(x):(y))
#endif

ped_canvas::ped_canvas(wxFrame *p,int gens,pedparms *given_pp,char *fn)
 : drawer(&memDC,gens,given_pp),
 wxFrame(p,fn,20,20,200,200)
{ viewer=0; canvas_is_busy=1; }

ped_canvas::~ped_canvas() { ; }

ped_canvas::OnClose()
{
if (viewer) delete viewer;
canvas_is_busy=0;
return TRUE;
}

volatile int canvas_is_busy;

view_canvas::view_canvas(wxMemoryDC *buff,wxFrame *frame,int x,int y, int w,int h,long style) :
wxCanvas(frame,x,y,w,h,style)
{
buffer=buff;
width=w; height=h;
}

void view_canvas::setWH(int w, int h)
{ width=w; height=h; }


void view_canvas::OnPaint()
{
GetDC()->BeginDrawing();
GetDC()->Clear();
GetDC()->Blit(0,0,width,height,buffer,0,0,wxCOPY);
GetDC()->EndDrawing();
}

void ped_canvas::OnSize(int w,int h)
{
int ww, hh;
wxFrame::OnSize(w,h);
#if 0
viewer->SetScrollbars(20,20,
  drawer.get_max_width()/20+1,drawer.get_max_height()/20+1,4,4);
viewer->GetClientSize(&ww,&hh);
viewer->setWH(ww<drawer.get_max_width()?ww:ww*(drawer.get_max_width()/20+1),
  hh<drawer.get_max_height()?drawer.get_max_height():(drawer.get_max_height()/20+1));
viewer->SetSize(0,0,ww<drawer.get_max_width()?ww:ww*(drawer.get_max_width()/20+1),
  hh<drawer.get_max_height()?drawer.get_max_height():(drawer.get_max_height()/20+1));
viewer->SetScrollbars(ww<drawer.get_max_width()?20:0,hh<drawer.get_max_height()?20:0,drawer.get_max_width()/20+1,drawer.get_max_height()/20+1,4,4);
viewer->OnPaint(); // do I need this?
#endif


#if 0
GetClientSize(&ww, &hh);
viewer->setWH(ww,hh);
viewer->SetSize(0,0,ww,hh);
viewer->OnPaint(); // do I need this?
#endif
}

void ped_canvas::display()
{
int ww, hh;
SetSizeHints(50,50,max(50,drawer.get_max_width()+30),max(50,drawer.get_max_height()+30));
GetClientSize(&ww, &hh);
viewer = new view_canvas(&memDC,(wxFrame*)this,
				 0, 0, ww, hh,
				 wxBORDER);
Show(TRUE);
viewer->SetScrollbars(20,20,
  drawer.get_max_width()/20+1,drawer.get_max_height()/20+1,4,4);
viewer->setWH(20*(drawer.get_max_width()/20+1),20*(drawer.get_max_height()/20+1));
}


void wx_tre_file::draw_loopable_line()
{
if (dropping<=0)
  draw(0,0.5,1,0.5);
else
  {
#if 1
  draw(0,0.5,dropping-0.25,0.5);
  draw(dropping-0.25,0.5,dropping-0.25,0.75);
  draw(dropping-0.25,0.75,dropping+0.25,0.75);
  draw(dropping+0.25,0.75,dropping+0.25,0.5);
  draw(dropping+0.25,0.5,1.0,0.5);
#else
  dc->DrawLine(curr_x,this_height-(curr_y+sq_h/2-1),
  curr_x+sq_w/2-sq_w/4,this_height-(curr_y+sq_h/2-1));
  dc->DrawLine(curr_x+sq_w/2-sq_w/4,this_height-(curr_y+sq_h/2-1),
  curr_x+sq_w/2-sq_w/4,this_height-(curr_y+sq_h/2-1+sq_h/4));
  dc->DrawLine(curr_x+sq_w/2-sq_w/4,this_height-(curr_y+sq_h/2-1+sq_h/4),
  curr_x+sq_w/2+sq_w/4,this_height-(curr_y+sq_h/2-1+sq_h/4));
  dc->DrawLine(curr_x+sq_w/2+sq_w/4,this_height-(curr_y+sq_h/2-1+sq_h/4),
  curr_x+sq_w/2+sq_w/4,this_height-(curr_y+sq_h/2-1));
  dc->DrawLine(curr_x+sq_w/2+sq_w/4,this_height-(curr_y+sq_h/2-1),
  curr_x+sq_w-1,this_height-(curr_y+sq_h/2-1));
#endif
  }
}

wx_tre_file::get_width_of_col(table &tab,int c)
{
return (c%2)?gap_w:sym_w;
}

wx_tre_file::get_height_of_row(table &tab,int r)
{
int height=(r%2)?gap_h:sym_h+tab.nglines(r,0)*char_height;
if (r<tab.get_hi_gen()*2-1)
  height+=extra_line_h*tab.extra_line[r+1].size();
if (r==0)
  height+=extra_line_h*tab.extra_line[r].size();
return height;
}

wx_tre_file::output_section(int s,table &tab)
{
if (title) dc->DrawText(title,pp->border_w,this_height-pp->border_h-char_height);
dc->EndDrawing();
return 1;
}

wx_tre_file::finish_output()
{
return 1;
}

wxmem_tre_file::~wxmem_tre_file()
{
((wxMemoryDC*)dc)->SelectObject(0);
if (buffer) delete buffer;
}


wxmem_tre_file::set_section(int s,table& tab,int forkey)
{
buffer=new wxBitmap(max_width,max_height,1);
((wxMemoryDC*)dc)->SelectObject(buffer);
dc->Clear();
return wx_tre_file::set_section(s,tab,forkey);
}

wx_tre_file::set_section(int s,table& tab,int forkey)
{
if (s/sects_wide==sects_high-1 && s%sects_wide==0)  // always at left
  title=tab.get_title();
else title=0;
if (s%sects_wide)
  {
  off_x+=this_width;
  minc=maxc+1;
  }
else //new row
  {
  off_x=-pp->border_w;
  minc=0;
  minr=s?maxr+1:0;
  off_y=s?off_y+this_height:-pp->border_h;
  }
int newbit;
for (maxc=minc,this_width=0;maxc<tab.get_num_col_pairs()*2 &&
      this_width+
      (newbit=get_width_of_col(tab,maxc)+get_width_of_col(tab,maxc+1))
       <=get_max_width()-2*pp->border_w;maxc+=2)
          this_width+=newbit;
this_width+=2*pp->border_w;
--maxc;
if (forkey && (s+1)%sects_wide==0) this_width=60*char_width;
else if (title)
  this_width=max(this_width,strlen(title)*char_width);
for (maxr=minr,this_height=0;maxr<min(tab.get_num_gens(),gen_to_print)*2 &&
     this_height+
     (newbit=get_height_of_row(tab,maxr)+get_height_of_row(tab,maxr+1))
       <=get_max_height()-2*pp->border_h;
     maxr+=2)
        this_height+=newbit;
this_height+=2*pp->border_h;
--maxr;
return 1;
}

void wx_tre_file::clear_brush()
{
dc->SetBrush(wxTheBrushList->FindOrCreateBrush(wxWHITE,wxSOLID));
}

void wx_tre_file::set_right_brush(int shade)
{
int style;
switch (shade)
  {
  case 1: style=wxSOLID; break;
  case 3: style=wxBDIAGONAL_HATCH; break;
  case 4: style=wxCROSSDIAG_HATCH; break;
  case 5: style=wxFDIAGONAL_HATCH; break;
  case 6: style=wxCROSS_HATCH; break;
  case 7: style=wxHORIZONTAL_HATCH; break;
  case 8: style=wxVERTICAL_HATCH; break;
  default: return;
  }
dc->SetBrush(wxTheBrushList->FindOrCreateBrush(wxBLACK,style));
}

void wx_tre_file::sort_shading(int shade,char *inset)
{
switch (shade)
  {
  case 20:
    dc->SetBrush(wxTheBrushList->FindOrCreateBrush(wxBLACK,wxSOLID));
    dc->DrawEllipse(curr_x+sq_w/4,this_height-(curr_y+sq_h*3/4-1),sq_w/2,(sq_h-1)/2);
    clear_brush();
    break;
  case 21:
    shape_label("?");
    break;
  case 22:
    shape_label("!");
    break;
  case 23:
    shape_label("X");
    break;
  }
if (inset) shape_label(inset);
}

void wx_tre_file::draw_dead()
{
int rx=sq_w/4;
int ry=sq_h/4;
dc->DrawLine(curr_x-rx,this_height-(curr_y-ry),curr_x+sq_w+rx,this_height-(curr_y+sq_h+ry));
}

void wx_tre_file::draw_diamond(int sh,char *inset)
{
wxPoint corners[4];
int shade=sh%100;
int tr=this_height-(curr_y+sq_h-1);
int rx=sq_w/2;
int ry=sq_h/2;
int cx=curr_x+rx;
int cy=tr+ry;
corners[0].x=cx-rx;
corners[1].y=cy-ry;
corners[2].x=cx+rx;
corners[3].y=cy+ry;
corners[0].y=corners[2].y=cy;
corners[1].x=corners[3].x=cx;
set_right_brush(sh);
dc->DrawPolygon(4,corners);
if (shade==2)
  {
  set_right_brush(1);
  dc->DrawPolygon(3,corners);
  }
sort_shading(shade,inset);
clear_brush();
if (sh>99) draw_dead();
}

void wx_tre_file::draw_square(int sh,char *inset)
{
wxPoint corners[4];
int shade=sh%100;
int tr=this_height-(curr_y+sq_h-1);
int rx=sq_w/2;
int ry=sq_h/2;
int cx=curr_x+rx;
int cy=tr+ry;
corners[0].x=corners[3].x=cx-rx;
corners[1].x=corners[2].x=cx+rx;
corners[0].y=corners[1].y=cy+ry;
corners[2].y=corners[3].y=cy-ry;
set_right_brush(sh);
dc->DrawPolygon(4,corners);
if (shade==2)
  {
  corners[0].y=corners[1].y=cy;
  set_right_brush(1);
  dc->DrawPolygon(4,corners);
  }
clear_brush();
sort_shading(shade,inset);
if (sh>99)
  draw_dead();
}

void wx_tre_file::draw_circle(int sh,char *inset)
{
int shade=sh%100;
set_right_brush(sh);
dc->DrawEllipse(curr_x,this_height-(curr_y+sq_h-1),sq_w,sq_h-1);
if (shade==2)
  {
  set_right_brush(1);
  dc->DrawArc(curr_x+sq_w,this_height-(curr_y+sq_h-1)+(sq_h-1)/2,
              curr_x,this_height-(curr_y+sq_h-1)+(sq_h-1)/2,
              curr_x+sq_w/2,this_height-(curr_y+sq_h-1)+(sq_h-1)/2);
  }
clear_brush();
sort_shading(shade,inset);
if (sh>99)
  draw_dead();
}

void wx_tre_file::draw_item(table& tab,int r,int c)
{
table_item *item=tab.item[r][c];
//if (!item) return 1;
sq_w=(c%2)?gap_w:sym_w;
sq_h=(r%2)?gap_h:sym_h;
curr_x=(sym_w+gap_w)*(c/2)+((c%2)?sym_w:0)-off_x;
curr_y=get_max_height()+1+off_y-sq_h;
for (int i=0;i<r;++i)
  curr_y-=get_height_of_row(tab,i);

if (r==0 && tab.extra_line[0].size()) // first row only
  {
  curr_x=(sym_w+gap_w)*(c/2)+((c%2)?sym_w:0)-off_x;
  curr_y+=sq_h;
  int nl=tab.extra_line[0].size();
  sq_h=extra_line_h;
  dropping=0;
  tab.extra_line[0].start();
  for (int l=0;l<nl;++l)
    {
    curr_y-=extra_line_h;
#if 0
    extra_h=(nl-l-1)*extra_line_h;
#else
    extra_h=0;
#endif
    TABLE_ROW hi_row=tab.extra_line[0].get();
    if (hi_row[c])
       {
       hi_row[c]->draw(this);
       dropping=(hi_row[c]->drops()==-1)?0:
               hi_row[c]->drops()?hi_row[c]->drops():dropping;
       }
    if (dropping && (!hi_row[c] || hi_row[c]->drops()==0))
      draw(dropping,1,dropping,0);
    tab.extra_line[0].fwd();
    }
  sq_h=(r%2)?gap_h:sym_h;
  curr_y-=sq_h;
  }

extra_h=(r%2)?0:tab.nglines(r,c)*char_height;
#if 0
if (r<tab.get_hi_gen()*2-1)
  extra_h+=extra_line_h*tab.extra_line[r+1].size();
#endif
dropping=0;
if (item) item->draw(this);
if (item && item->is_a_person()) //person
  {
  for (int l=0,i=1;l<=ROWS;++l)
    {
    if (tab.get_t_line(l))
       {
       char s[MAXSTR+1];
       int len=min(MAXSTR,(sym_w+gap_w)/char_width);
       if (tab.item[r][c]->get_draw_stat()==REP && l!=0)
         { print("REP",i); break; }
       if (l!=0)
           tab.item[r][c]->print(s,l,len,MIDSTR,MSCOL);
       else
         {
         char buffer[MAXSTR+1];
         tab.item[r][c]->print(buffer,l,MAXSTR,MIDSTR,MSCOL);
         sscanf(buffer," %s ",s);  // lose following spaces and gender
         if (strchr(s,'-') > s)   // LS4
           len=min(len,strlen(strchr(s,'-'))+1);
         else len=min(len,3);
         tab.item[r][c]->print(s,l,-len,MIDSTR,MSCOL);
         }
       print(s,i);
       ++i;
       }
    }
  }
if (r<tab.get_hi_gen()*2-1 && tab.extra_line[r+1].size())
  {
  int nl=tab.extra_line[r+1].size();
  sq_h=extra_line_h;
  dropping=(item && item->drops()>0)?item->drops():0;
  tab.extra_line[r+1].start();
  for (int l=0;l<nl;++l)
    {
    curr_y-=extra_line_h;
#if 0
    extra_h=(nl-l-1)*extra_line_h;
#else
    extra_h=0;
#endif
    TABLE_ROW hi_row=tab.extra_line[r+1].get();
    if (hi_row[c])
       {
       hi_row[c]->draw(this);
       dropping=(hi_row[c]->drops()==-1)?0:
               hi_row[c]->drops()?hi_row[c]->drops():dropping;
       }
    if (dropping && (!hi_row[c] || hi_row[c]->drops()==0))
       draw(dropping,1,dropping,0);
    tab.extra_line[r+1].fwd();
    }
  }
}

void wx_tre_file::draw(float x1,float y1,float x2,float y2,int col)
{
#if 0
line[FG_X1]=curr_x+min(x1*sq_w,sq_w-1);
line[FG_X2]=curr_x+min(x2*sq_w,sq_w-1);
line[FG_Y1]=curr_y+(y1?y1*(sq_h-1):-extra_h);
line[FG_Y2]=curr_y+(y2?y2*(sq_h-1):-extra_h);
#else
#if 1
dc->DrawLine(curr_x+min(x1*sq_w,sq_w-1),
this_height-(curr_y+(y1?y1*(sq_h-1):-extra_h)),
curr_x+min(x2*sq_w,sq_w-1),
this_height-(curr_y+(y2?y2*(sq_h-1):-extra_h)));
#else
dc->DrawLine(curr_x+min(x1*sq_w,sq_w-1),
this_height-(curr_y+y1*(sq_h-1)),
curr_x+min(x2*sq_w,sq_w-1),
this_height-(curr_y+y2*(sq_h-1)));
#endif
#endif
}

void wx_tre_file::print(char *s,int i)
{
dc->DrawText(s,curr_x,this_height-(curr_y-(i-1)*char_height-1));
}

wxmem_tre_file::wxmem_tre_file(wxDC *given_dc,int gens,pedparms *given_pp)
: wx_tre_file(given_dc,gens,given_pp)
{ buffer=0; }

wx_tre_file::wx_tre_file(wxDC *given_dc,int gens,pedparms *given_pp)
: gr_table_output_device(given_pp->unsex,given_pp->no_diag)
{
gen_to_print=gens; // over-ridden for key
pp=given_pp;
sym_h=pp->sym_h;  // maybe we'll need copies of these
sym_w=pp->sym_w;
gap_h=pp->gap_h;
gap_w=pp->gap_w;
extra_line_h=pp->extra_line_h;
dc=given_dc;
}

wx_tre_file::save()
{
return 1;
}

wx_tre_file::~wx_tre_file()
{ ; }

wx_tre_file::get_no_sections(table& tab,int forkey)
{
int i,j,width,height;
width=height=0;
sects_wide=sects_high=1;
dc->SetBackgroundMode(wxTRANSPARENT);
dc->SetPen(wxThePenList->FindOrCreatePen(wxBLACK,1,wxSOLID));
dc->SetBrush(wxTheBrushList->FindOrCreateBrush(wxWHITE,wxSOLID));
dc->SetBackground(wxTheBrushList->FindOrCreateBrush(wxWHITE,wxSOLID));
dc->SetFont(wxTheFontList->FindOrCreateFont(12,wxROMAN,wxNORMAL,wxNORMAL));
#if 0 // doesn't work for postscript
char_height=dc->GetCharHeight();
char_width=dc->GetCharWidth();
#else
float ch,cw;
dc->GetTextExtent("M",&cw,&ch);
char_height=ch;
char_width=cw;
#endif
int adding;
for (i=j=0;i<tab.get_num_col_pairs()*2;i+=2)
   {
   adding=get_width_of_col(tab,i)+get_width_of_col(tab,i+1);
   j+=adding;
   }
width+=j;
if (forkey) width=60*char_width;
else if (tab.get_title())
  width=max(width,strlen(tab.get_title())*char_width);
for (i=j=0;i<min(tab.get_num_gens(),gen_to_print)*2;i+=2)
   {
   adding=get_height_of_row(tab,i)+get_height_of_row(tab,i+1);
   j+=adding;
   }
height+=j;
set_max_height(height+2*pp->border_h);
set_max_width(width+2*pp->border_w);
sects_wide=sects_high=1;
rinc=1;
cinc=1;
return 1;
}

wxmem_tre_file::get_no_sections(table& tab,int forkey)
{
wxBitmap *temp=new wxBitmap(100,100,1);
((wxMemoryDC*)dc)->SelectObject(temp);
int rv=wx_tre_file::get_no_sections(tab,forkey);
((wxMemoryDC*)dc)->SelectObject(0);
delete temp;
return rv;
}

void wx_tre_file::shape_label(char *s)
{
float w,h;
dc->GetTextExtent(s,&w,&h);
dc->DrawText(s,curr_x+(sq_w-w)/2,this_height-(curr_y+(sq_h+h)/2));
}

int wx_tre_file::get_max_height() { return max_height; }
int wx_tre_file::get_max_width() { return max_width; }
void wx_tre_file::set_max_height(int h) { max_height=h; }
void wx_tre_file::set_max_width(int w) { max_width=w; }
