/* PEDMSP.HPP */
/* Copyright Dave Curtis 1991 */
#ifndef PEDMSPHPP
#define PEDMSPHPP 1

#include "allwx.hpp"
#include "pedout.hpp"
#include "pedtable.hpp"

class wx_tre_file : public gr_table_output_device
{
int char_height,char_width;
int gen_to_print;
int sects_high,sects_wide,sect_height,sect_width;
char filename[65];
virtual output_section(int s,table& tab);
virtual void draw_item(table& tab,int r, int c);
get_height_of_row(table &tab,int r);
get_width_of_col(table &tab,int c);
int this_height,this_width;
float dropping;
protected:
pedparms *pp;
int max_height,max_width;
wxDC *dc;
virtual get_no_sections(table& tab,int forkey);
virtual set_section(int s,table& tab,int forkey);
virtual void set_max_height(int h);
virtual void set_max_width(int w);
finish_output();
void draw_dead();
void draw(float x1,float y1,float x2,float y2,int col=1); //draw lines in unit box
int sym_h,sym_w,gap_h,gap_w,extra_line_h;
int curr_x,curr_y,off_x,off_y,sq_w,sq_h,extra_h;
virtual void draw_square(int shade,char *inset);
virtual void draw_circle(int shade,char *inset);
virtual void draw_diamond(int shade,char *inset);
void draw_loopable_line();
void print(char *s,int l);
void shape_label(char *s);
void sort_shading(int shade,char *inset);
void set_right_brush(int shade);
void clear_brush();
public:
virtual int get_max_height(); // use for canvas
virtual int get_max_width();
wx_tre_file(wxDC *dc,int gens,pedparms *given_pp);
~wx_tre_file();
int save();
};

class wxmem_tre_file : public wx_tre_file
{
virtual get_no_sections(table& tab,int forkey);
virtual set_section(int s,table& tab,int forkey);
public:
wxBitmap *buffer;
wxmem_tre_file(wxDC *dc,int gens,pedparms *given_pp);
~wxmem_tre_file();
};

class view_canvas : public wxCanvas {
wxMemoryDC *buffer;
int width,height;
public:
view_canvas(wxMemoryDC *buff,wxFrame *frame,int x,int y, int w,int h,long style);
void OnPaint();
void setWH(int w,int h);
};


class ped_canvas : public wxFrame {
wxMemoryDC memDC;
view_canvas *viewer;
wxFrame *parent;
public:
ped_canvas(wxFrame *p,int gens,pedparms *given_pp,char *fn);
~ped_canvas();
void display();
wxmem_tre_file drawer;
OnClose();
void OnSize(int w,int h);
};

extern volatile int canvas_is_busy;
#endif

