// add inset string
// reads cfg in home then current directory
// history feature added
// c flag added
// fixed fgram bug for X model

/* PEDMAIN.CPP */
/* Copyright Dave Curtis 1991 */
#include "winmenu.hpp"
#include "dcerror.hpp"
#include "pedraw.hpp"
#include "pedlink.hpp"
#include "pededit.hpp"
#include "dcutils.hpp"
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#define VERSION "1.8"
#define PPVERSION "1.8"

#define SWITCHCHAR '-'

FILE *input_file=0;
static FILE *fp_exist;
#define exists(fn) ((fp_exist=fopen(fn,"r"))!=0 && (fclose(fp_exist),1))

extern void edit_help(int h);
extern char *ed_str,*ESCF1,*ESCF10,*CURENT,*flag_help_str;
extern int do_switch(char *s);

int changed,saved=1;
char *NL_STR; // pedlink.cxx likes to have this
int I_want_to_exit=0;
dcwindow prompt_window((wxFrame**)&mainframeptr,"PEDRAW message",4,6,8,79);
dcwindow big_window(0,"PEDRAW information",15,40,24,79);
dcwindow input_window(0,"PEDRAW input",8,6,12,73);
extern winmenu mmenu,list_window; // seems these are not actually defined?

extern void flag_help(void);



void help_message(char *message, va_list arg_ptr)
{
char buff[2000];
vsprintf(buff,message,arg_ptr);
wxMessageBox(buff,"",wxOK,mainframeptr,10,30);
}

void show_help(char *s,...)
{
va_list arg_ptr;
va_start(arg_ptr,s);
help_message(s,arg_ptr);
va_end(arg_ptr);
}

void vlog(char *s,va_list arg_ptr)
{
prompt_window.vprintf(s,arg_ptr);
}

void vprompt(char *s,va_list arg_ptr)
{
prompt_window.clear();
prompt_window.vprintf(s,arg_ptr);
}

void prompt(char *s,...)
{
va_list arg_ptr;
va_start(arg_ptr,s);
vprompt(s,arg_ptr);
va_end(arg_ptr);
}

char spec[81]="*.*";

int choose_member(tab_pedigree &ped,int start=0)
{
char s[81];
char buffer[21];
if (!ped.size())
  {
  dcerror(3,"Pedigree is empty");
  return -1;
  }
int w=-1;
winmenu list_window(6,7);
// just a dummy, this isn't actually used for the member choice
if (!input_file)
    return ped.select(input_window,"ID of member",list_window,"Pedigree is empty",start);
else while (input_file)
    {
    if (dcerror.stat())
      {
      fclose(input_file);
      input_file=NULL;
      dcerror.clear();
      return -1;
      }
    input_window.clear();
    input_window.puts("*** In batch mode:  Reading input from file ***");
    *buffer=0;
    if (!input_window.fgets(s,80,input_file))
      {
      if (input_file) fclose(input_file);
      input_file=0;
      if (pparms.default_output_type=='S') { input_window.suspend(); prompt_window.suspend(); }
      return -1;
      }
    else if (sscanf(s," %20s ",buffer),!*buffer) return -1;
    else if (buffer[0]=='-') do_switch(s);
    else
      {
      strcpy(s,buffer);
      if (!strcmp(s,"EXIT"))
        {
        fclose(input_file);
        input_file=0;
        I_want_to_exit=1;
        return -1;
        }
      w=ped.which(s);
      if (w==-1)
        {
        dcerror(4,"%s not found in pedigree",s);
        if (input_file) fclose(input_file);
        input_file=0;
        return -1;
        }
      else return w;
      }
    }
return -1; //menus chosen or error
}

void flag_help()
{
      show_help(flag_help_str);
}



int choose_file(char *s,char *pr,char *supplied_spec)
{
static char kept_spec[81]="*.*";
char spec[81];
strcpy(spec,supplied_spec?supplied_spec:kept_spec);
char *rv;
rv=wxFileSelector(pr?pr:"Choose file",NULL,spec,NULL,spec);
if (rv) strcpy(s,rv);
return rv!=NULL;
}

char *flag_help_str=
"\
-b or -b1       Blank out diagnoses (no shading)\n\
-b0             show diagnoses\n\
-a or -a1       show All pedigree, including pedigrees marrying in\n\
-a0             show only descendants of named individual\n\
-l0 to -l11     show numbered Line (0 is inset in symbol, 1 is ID)\n\
-l-0 to -l-11   don't show numbered Line\n\
-g#             number of Generations to print\n\
-ttitle         Title for picture\n\
-ffilename      save to filename, just -f for default\n\
-c#   -r#       maximum number of Columns and Rows in table\n\
-sh#  -sw#      Symbol Height and Symbol Width\n\
-gh#  -gw# -h#  Gap Height, Gap Width, extra line Height\n\
-bh#  -bw#      Border Height and Border Width\n\
-psx# -psy#     Postscript X and Y Scales\n\
-ptx# -pty#     Postscript X and Y Translation\n\
-pl or -pl1     Postscript Landscape orientation\n\
-pl0            Postscript portrait orientation\n"
#ifdef wx_msw
"-oP/B/I/S       Output to Postscript/BMP/prInter/Screen\n"
#else
"-oP/X/S         Output to Postscript/XPM/Screen\n"
#endif
"-cfilename      read in given Configuration file\n"
"-m or -m1       use Menus\n"
"-mfilename      don't use Menus (i.e. batch mode)\n";


pedparms pparms;

table *tab;

int do_switch(char *s)
{
char buff[31];
int i;
while (strchr(s,'-'))
 {
 s=strchr(s,'-')+1;
 sscanf(s,"%30[^ \n]",buff);
 strupr(buff);
 switch (buff[0])
   {
   case 'M':
     if (buff[1]=='1' || buff[1]=='\0')
       {
       if (!pparms.input_file_name.is_null()) pparms.input_file_name.strfree();
       if (input_file)
         { fclose(input_file); input_file=NULL; }
       }
     if (!pparms.input_file_name.assign(buff+1))
            return dcerror(ENOMEM,"Out of memory setting input file name");
     break;
   case 'T':
     sscanf(s+1,"%64[^/\n]",pparms.title_str);
     s=strchr(s,'\0'); // do not read any more from line
     break;
   case 'O':
     if (!strchr(LEGAL_OUTPUT_TYPES,buff[1]))
       return dcerror(1,"Bad output type %c (must be one of %s)",buff[1],LEGAL_OUTPUT_TYPES);
     else pparms.default_output_type=buff[1];
     break;
   case 'F':
     if (buff[1] && !pparms.save_file.assign(buff+1))
            return dcerror(ENOMEM,"Out of memory setting file name");
     break;
   case 'B':
     if (buff[1]=='0') pparms.no_diag=0;
     else if (buff[1]=='\0' || buff[1]=='1') pparms.no_diag=1;
     else if (buff[1]=='H') pparms.border_h=atoi(buff+2);
     else if (buff[1]=='W') pparms.border_w=atoi(buff+2);
     break;
   case 'U':
     if (buff[1]=='0') pparms.unsex=0;
     else pparms.unsex=1;
     break;
   case 'A':
     if (buff[1]=='0') pparms.extend=0;
     else pparms.extend=1;
     break;
   case 'L':
     i=atoi(buff+1);
     if (i && abs(i)<=ROWS+1)
       {
       pparms.t_lines[abs(i)-1]=(i>0);
       *pparms.t_line_str='\0';
       for (i=0;i<ROWS+1;++i)
        if (pparms.t_lines[i])
          sprintf(strchr(pparms.t_line_str,'\0'),"%s%d",
                 *pparms.t_line_str?",":"",i+1);
       }
     else if (buff[1]=='0') pparms.inset=1;
     else if (buff[1]=='-' && buff[2]=='0') pparms.inset=0;
     break;
   case 'R':
     if ((i=atoi(buff+1))>0)
       pparms.max_gen=i;
     break;
   case 'C':
     if ((i=atoi(buff+1))>0)
       pparms.max_wid=i;
     else if (!pparms.load(buff[1]=='\0'?"pedraw.cfg":buff+1,PPVERSION))
        return dcerror(1,"Problem with %s - could not load configuration file %s\n",
          buff,buff[1]=='\0'?"pedraw.cfg":buff+1);
     break;
     break;
   case 'H':
     if ((i=atoi(buff+1))>3)
       pparms.extra_line_h=i;
     break;
   case 'P':
     if (buff[1]=='L') pparms.ps_landscape=(buff[2]!='0');
     else
       {
       sscanf(buff,"PSX%lf",&pparms.ps_x_scale);
       sscanf(buff,"PSY%lf",&pparms.ps_y_scale);
       sscanf(buff,"PTX%lf",&pparms.ps_x_trans);
       sscanf(buff,"PTY%lf",&pparms.ps_y_trans);
       // only one of these will work
       }
     break;
   case 'S':
     if (buff[1]=='H')
        {
        if ((i=atoi(buff+2))>3) pparms.sym_h=i;
        }
     else if (buff[1]=='W')
        {
        if ((i=atoi(buff+2))>3) pparms.sym_w=i;
        }
     break;
   case 'G':
     if (toupper(buff[1]=='H'))
        {
        if ((i=atoi(buff+2))>3) pparms.gap_h=i;
        }
     else if (toupper(buff[1]=='W'))
        {
        if ((i=atoi(buff+2))>3) pparms.gap_w=i;
        }
     else if ((i=atoi(buff+1))>1)
       pparms.gen_to_print=i;
     break;
   default:
     dcerror(2,"\nBad switch: -%s\n%s\n",buff,flag_help_str);
     return 0;
   }
 if (buff[0]!='T') s+=strlen(buff); // move over this arg
 }
return 1;
}

extern editable_pedparms pp_ed;

configure()
{
char s[65];
int c;
prompt("Enter ? for help");
*s='\0';
if (input_window.gets(s,-1,"Enter flags or leave blank to use window-editor:"))
    {
    if (!strcmp(s,"?"))
       {
       flag_help();
       input_window.clear();
       *s='\0';
       if (!input_window.gets(s,-1,"Enter flags or leave blank to use window-editor:")) return 0;
       }
    if (*s)
      return do_switch(s);
    else
      {
      editable_pedparms pp_ed;
      return pparms.revise(pp_ed);
      }
    }
else return 0;
}

enum filetype_e{DAT=1,SDF,PED,PPD,GED};

int loadfile(char *s,tab_pedigree &ped,int filetype)
{
data_file file;
if (!saved && wxMessageBox("Really load new file without saving pedigree data?","WPEDRAW message",wxYES_NO)!=wxYES) return 0;
winmenu lfmenu(6,7,"DAT file (PEDRAW)^SDF file (LINKSYS)^PED file (before MAKEPED)^PPD file (after MAKEPED)^GED file (GEDCOM)");
if (filetype==0) // don't know
  {
  if (strstr(s,".DAT")||strstr(s,".dat")) filetype=DAT;
  else if (strstr(s,".PED")||strstr(s,".ped")) filetype=PED;
  else if (strstr(s,".PPD")||strstr(s,".ppd")) filetype=PPD;
  else if (strstr(s,".SDF")||strstr(s,".sdf")) filetype=SDF;
  else if (strstr(s,".GED")||strstr(s,".ged")) filetype=GED;
  else
    {
    if (input_file) { fclose(input_file); input_file=0; }
    prompt("Indicate format of file");
    if ((filetype=lfmenu.choose())==0) return 0;
    }
  }
if (!file.open(s,"r")) return 0;
tab_person *temp;
ped.clear();
saved=1;
changed=1;
for (;;)
        {
        if ((temp=new tab_person)==0)
           return dcerror(ENOMEM,"Out of memory making temp tab_person");
        ped_person pedtemp,*pp;
        ppd_person *ppdp;
        linksys_person *ls;
        switch (filetype)
           {
           case DAT:
             if (!temp->input(file))
               { delete temp; temp=0; }
             break;
           case GED:
             if (!temp->ged_input(file))
               { delete temp; temp=0; }
             break;
           case PPD:
            ppdp=new ppd_person;
             if ((!ppdp && !dcerror(ENOMEM,"Out of memory making temp ppd_person"))
                || !ppdp->input(file))
               { delete temp; temp=0; }
             else
               {
               pedtemp=*ppdp;
               temp->from_ped(pedtemp);
               }
             delete ppdp;
             break;
           case PED:
             pp=new ped_person;
             if ((!pp && !dcerror(ENOMEM,"Out of memory making temp ped_person"))
                || !pp->input(file))
               { delete temp; temp=0; }
             else temp->from_ped(*pp);
             delete pp;
             break;
           case SDF:
            ls=new linksys_person;
             if ((!ls && !dcerror(ENOMEM,"Out of memory making temp linksys_person"))
                || !ls->input(file))
               { delete temp; temp=0; }
            else temp->from_ls(*ls);
            delete ls;
            break;
          }
        if (dcerror.stat()) { if (temp) delete temp; return 0; }
        if (!temp) break;
        else ped.add_member(temp);
#ifdef wx_msw
        prompt("%d read OK",ped.size());
#endif
        }
if (filetype==GED)
  {
  file.close();
  if (!file.open(s,"r")) return 0;
  if (!ped.read_ged_fams(file)) return 0;
  }
return 1;
}

do_revising(tab_pedigree &ped)
{
editable_tab_person tp_ed;
// use local editor to avoid problems with delete panel[p]
ped.clear_pointers();
changed=1;
#ifndef using_wx
winmenu amenu(&ws,6,7,"Add member^Remove member^Edit member^Promote member^Demote member^Clear data");
#else
winmenu amenu(6,7,"Add member^Remove member^Edit member^Promote member^Demote member^Clear data");
#endif
int c=-1,ach=0;
#ifndef using_wx
while (prompt(CURENT),input_window.suspend(),(ach=amenu.choose(ach))!=0)
#else
while (input_window.suspend(),(ach=amenu.choose(ach))!=0)
#endif
  {
  switch (ach)
    {
    case 1:
      tab_person *temp;
      while (((temp=new tab_person)!=0 || dcerror(ENOMEM,"Out of memory making temp tab_person"))
                 && temp->revise(tp_ed))
         { ped.add_member(temp); changed=1; saved=0; }
      break;
    case 2:
      while (prompt("Select an individual to remove (ESC when finished)"),(c=choose_member(ped,c))!=-1)
        { ped.remove(c); changed=1; saved=0; }
      break;
    case 3:
      while (prompt("Select an individual to edit (ESC when finished)"),(c=choose_member(ped,c))!=-1)
        if (ped.edit(c,tp_ed)) { changed=1; saved=0; }
      break;
    case 4:
      prompt("Select an individual to move to start of list (ESC when finished)");
      while ((c=choose_member(ped,c))!=-1)
        { ped.move_to_start(c); changed=1; saved=0; }
      break;
    case 5:
      prompt("Select an individual to move to end of list (ESC when finished)");
      while ((c=choose_member(ped,c))!=-1)
        { ped.move_to_end(c); changed=1; saved=0; }
      break;
    case 6:
      if (!saved && wxMessageBox("Really clear current data without saving?","WPEDRAW message",wxYES_NO)!=wxYES) break;
      ped.clear();
      saved=1;
      changed=1;
      break;
    }
  }
return 1;
}

display(tab_pedigree &ped,int output_type)
{
if ((tab=new table(pparms.max_gen,pparms.max_wid))==0 || dcerror.stat()) return 0;
if (changed)
  {
  ped.clear_pointers();
  dcerror.set_display(vlog);
  ped.do_pointers();
  dcerror.reset_display();
  if (!ped.is_valid())
    {
    dcerror(2,"There are problems with the data");
    return 0; // so allow some errors (like missing parents) but not others
    }
  if (dcerror.stat()) dcerror(2,"The data may be incomplete");
  changed=0;
  }
int c=0;
char s[241];
if (prompt("Select an individual whose descendants will be displayed"),
      (c=choose_member(ped,c))==-1) return 0;
else
// was while (), so could do several different members
    {
    if (output_type==0) output_type=
      pparms.default_output_type=='P'?PED_PS:
#ifndef wx_msw
      pparms.default_output_type=='X'?PED_XPM:
#else
      pparms.default_output_type=='B'?PED_BMP:
      pparms.default_output_type=='I'?PED_PRINT:
#endif
      pparms.default_output_type=='S'?PED_CANVAS:PED_TEXT;
    strcpy(s,ped.get_name(c));
    switch (output_type)
      {
      case PED_TEXT:
      case PED_PS:
#ifdef wx_msw
#if !(USE_IMAGE_LOADING_IN_MSW)
#error "MSW bitmaps not defined in wx_setup.h!!"
#endif
      case PED_BMP:
#else
#if !(USE_IMAGE_LOADING_IN_X)
#error "X bitmaps not defined in wx_setup.h!!"
#endif
      case PED_XPM:
#endif
      if (pparms.save_file.is_null())
        sprintf(s,"%s.%s",ped.get_name(c),
          output_type==PED_TEXT?"tre":
#ifdef wx_msw
          output_type==PED_BMP?"bmp":
#else
          output_type==PED_XPM?"xpm":
          output_type==PED_GIF?"gif":
#endif
          "ps");
      else strcpy(s,pparms.save_file);
      if (!input_file)
        {
        char *rv;
        char *spec=
        output_type==PED_TEXT?"*.tre":
#ifdef wx_msw
          output_type==PED_BMP?"*.bmp":
#else
          output_type==PED_XPM?"*.xpm":
          output_type==PED_GIF?"*.gif":
#endif
        "*.ps";
        rv=wxFileSelector("Choose file to write to",NULL,s,NULL,spec);
        if (rv) strcpy(s,rv); else return 0;
        }
      }
    tab_person *temp=(tab_person*)ped.get_anc(c);
    if (tab->sort_table_from(temp,pparms.extend)==0)
       { ped.clear_draw_data(); delete tab; return 0; }
       // table.clear() may not haved work if there was an error
    draw_ped(*tab,s,0,output_type);
    tab->clear();
//    prompt_window.select();
//    input_window.select();
    }
delete tab;
return 1;
}

class AltKeyWindow: public wxTextWindow
{
public:
AltKeyWindow(wxFrame *frame, int x=-1, int y=-1, int width=-1, int height=-1,
               long style=0):
  wxTextWindow(frame, x, y, width, height, wxNATIVE_IMPL)  { ; }
  void OnChar(wxKeyEvent& event);
};

void AltKeyWindow::OnChar(wxKeyEvent& event)
{ if (!isprint(event.keyCode)) wxTextWindow::OnChar(event); }

#define CHANGE_CONF     1
#define LOAD_CONF       2
#define SAVE_CONF       3
#define LOAD_PED     4
#define LOAD_PPD     16
#define LOAD_SDF     17
#define LOAD_DAT     18
#define LOAD_GED     24
#define SAVE_PED        5
#define MAKE_KEY     6
#define DISPLAY_PED_TEXT      7
#define DISPLAY_PED_PS      19
#define DISPLAY_PED_CANVAS      20
#ifdef wx_msw
#define DISPLAY_PED_BMP      21
#else
#define DISPLAY_PED_XPM      21
#define DISPLAY_PED_GIF      22
#endif
#define DISPLAY_PED_PRINT      23
#define PEDRAW_QUIT     8
#define ADD_MEMBER      9
#define EDIT_MEMBER     10
#define REMOVE_MEMBER   11
#define PROMOTE_MEMBER  12
#define DEMOTE_MEMBER   13
#define COMMAND_FILE    14
#define ADJUST_PED      15

// This statement initializes the whole application and calls OnInit
MyApp myApp;

tab_pedigree ped;

MyFrame *mainframeptr;
// `Main program' equivalent, creating windows and returning main app frame
wxFrame *MyApp::OnInit(void)
{
  // Create the main frame window
  MyFrame *frame = new MyFrame(NULL, "WPEDRAW v"VERSION, 0, 0, 400, 100);
mainframeptr=frame;

#if 0
  // Give it an icon
  frame->SetIcon(new wxIcon("aiai_icn"));
#endif

  // Make a menubar

  wxMenu *file_menu = new wxMenu;
  wxMenu *conf_menu = new wxMenu;
  wxMenu *display_menu = new wxMenu;
  file_menu->Append(LOAD_PED,"Load pre-MAKEPED file");
  file_menu->Append(LOAD_PPD,"Load post-MAKEPED file");
  file_menu->Append(LOAD_SDF,"Load DOLINK SDF file");
  file_menu->Append(LOAD_DAT,"Load PEDRAW DAT file");
  file_menu->Append(LOAD_GED,"Load GEDCOM GED file");
  display_menu->Append(DISPLAY_PED_CANVAS,"Display pedigree on screen");
  display_menu->Append(DISPLAY_PED_PS,"Produce postscript file");
#ifdef wx_msw
  display_menu->Append(DISPLAY_PED_BMP,"Produce BMP file");
  display_menu->Append(DISPLAY_PED_PRINT,"Output to printer");
#else
//  display_menu->Append(DISPLAY_PED_GIF,"Produce GIF file");
  display_menu->Append(DISPLAY_PED_XPM,"Produce XPM file");
#endif
  display_menu->Append(DISPLAY_PED_TEXT,"Output text pedigree");
//  file_menu->Append(MAKE_KEY,"Make key");
  file_menu->Append(ADJUST_PED,"Adjust pedigree");
  file_menu->Append(SAVE_PED,"Save pedigree file");
  file_menu->Append(COMMAND_FILE,"Input command file");
  file_menu->Append(PEDRAW_QUIT, "Quit");
  conf_menu->Append(CHANGE_CONF,"Change configuration");
  conf_menu->Append(LOAD_CONF,"Load old configuration");
  conf_menu->Append(SAVE_CONF,"Save configuration");

  wxMenuBar *menu_bar = new wxMenuBar;
  menu_bar->Append(file_menu, "File");
  menu_bar->Append(display_menu, "Output");
  menu_bar->Append(conf_menu, "Configuration");

  frame->SetMenuBar(menu_bar);

  wxTextWindow *key_catcher = new AltKeyWindow(frame); // to get character events
  // Make a panel with a message
  wxPanel *panel = new wxPanel(frame, 0, 0, 400, 300);
  (void)new wxMessage(panel, "PEDRAW (wxWindows version)");
  panel->NewLine();
  (void)new wxMessage(panel, "Copyright Dave Curtis 1990-6");
  // Return the main frame window

dcerror.warn();
dcerror.set_display(help_message);
input_window.set_history(1000);
#ifdef __MSDOS__
char cfg[81];
strcpy(cfg,argv[0]);
sprintf(strrchr(cfg,'\\'),"\\pedraw.cfg");
if (exists(cfg)) pparms.load(cfg,PPVERSION);
#else
if (exists("~/pedraw.cfg"))
  pparms.load("~/pedraw.cfg",PPVERSION);
#endif
if (exists("pedraw.cfg"))
  pparms.load("pedraw.cfg",PPVERSION);
for (int ag=(argc>1 && argv[1][0]!=SWITCHCHAR)?2:1;ag<argc;++ag)
   if ((argv[ag][0]!=SWITCHCHAR && !dcerror(1,"\nBad switch: %s\n",argv[ag]))
      || !do_switch(argv[ag])) wxExit();
if (argc>1 && argv[1][0]!=SWITCHCHAR)
   loadfile(argv[1],ped,0);
if (!pparms.input_file_name.is_null())
   {
   if (!dcerror.stat() &&
     (input_file=fopen(pparms.input_file_name,"r"))==0)
     dcerror(3,"Could not open input file %s",(char*)pparms.input_file_name);
   pparms.input_file_name.strfree();
   }
while (input_file && !dcerror.stat()) display(ped,0);
if (input_file) { fclose(input_file); input_file=NULL; }
if (I_want_to_exit) { frame->OnClose(); delete frame; return 0; }
frame->Show(TRUE);
return frame;
}

// My frame constructor
MyFrame::MyFrame(wxFrame *frame, char *title, int x, int y, int w, int h):
  wxFrame(frame, title, x, y, w, h)
{}

char s[65];
// Intercept menu commands
int im_busy=0;

Bool MyFrame::OnClose(void)
{
if (im_busy) return 0;
if (!saved && wxMessageBox("Really quit without saving pedigree data?","WPEDRAW message",wxYES_NO)!=wxYES) return 0;
return 1;
}
// I cannot be bothered to keep track of all subframes

void MyFrame::OnMenuCommand(int id)
{
static char cfg_spec[81]="*.cfg";
static char load_spec[80]="*.*";
static char command_spec[80]="*.inp";
int filetype;
if (im_busy) return;
im_busy=1;
dcerror.clear(); // I think OK to do this here
  switch (id) {
  case COMMAND_FILE:
    *s='\0';
    if (choose_file(s,"Select command file to read",command_spec)
       && !pparms.input_file_name.assign(s))
	 dcerror(ENOMEM,"Out of memory setting input file name");
    break;
  case CHANGE_CONF:
    configure();
    break;
  case LOAD_CONF:
    //prompt("Select file to load");
    *s='\0';
    if (choose_file(s,"Select configuration file to load",cfg_spec))
      pparms.load(s,PPVERSION);
    break;
  case SAVE_CONF:
    *s='\0';
    if (choose_file(s,
      "Select file to save to (pedraw.cfg for new default)",cfg_spec))
	 pparms.save(s,PPVERSION);
    break;
  case LOAD_PED:
    *s='\0';
    if (choose_file(s,"Select the pre-MAKEPED pedigree file to load in","*.ped"))
      loadfile(s,ped,PED);
    break;
  case LOAD_PPD:
    *s='\0';
    if (choose_file(s,"Select the post-MAKEPED pedigree file to load in","*.ppd"))
      loadfile(s,ped,PPD);
    break;
  case LOAD_SDF:
    *s='\0';
    if (choose_file(s,"Select the DOLINK SDF file to load in","*.sdf"))
      loadfile(s,ped,SDF);
    break;
  case LOAD_DAT:
    *s='\0';
    if (choose_file(s,"Select the PEDRAW DAT to load in","*.dat"))
      loadfile(s,ped,DAT);
    break;
  case LOAD_GED:
    *s='\0';
    if (choose_file(s,"Select the GEDCOM to load in","*.ged"))
      loadfile(s,ped,GED);
    break;
  case DISPLAY_PED_TEXT:
    display(ped,PED_TEXT);
    break;
  case DISPLAY_PED_PS:
    display(ped,PED_PS);
    break;
  case DISPLAY_PED_CANVAS:
    display(ped,PED_CANVAS);
    break;
#ifdef wx_msw
  case DISPLAY_PED_BMP:
    display(ped,PED_BMP);
    break;
#else
  case DISPLAY_PED_GIF:
    display(ped,PED_GIF);
    break;
  case DISPLAY_PED_XPM:
    display(ped,PED_XPM);
    break;
#endif
  case DISPLAY_PED_PRINT:
    display(ped,PED_PRINT);
    break;
  case ADJUST_PED:
    do_revising(ped);
    break;
  case SAVE_PED:
    *s='\0';
    if (choose_file(s,"Select the file to save the pedigree to","*.dat"))
      {
//      prompt("Saving pedigree in file %s",s);
      if (savefile(s,ped)) saved=1;
      }
    break;
  case PEDRAW_QUIT:
// #ifdef wx_xview
// flakey with exceedw/winsock
//    wxExit();
// #else
//"correct way"
    im_busy=0;
    OnClose();
    delete this;
    return;
// #endif
    break;
  }
if (!pparms.input_file_name.is_null())
      {
      if ((input_file=fopen(pparms.input_file_name,"r"))==NULL)
	dcerror(3,"Could not open input file %s",(char*)pparms.input_file_name);
      pparms.input_file_name.strfree();
      }
prompt_window.suspend();
while (input_file && !dcerror.stat()) display(ped,0);
if (input_file) { fclose(input_file); input_file=NULL; }
if (I_want_to_exit) { OnClose(); delete this; return; }
mainframeptr->Iconize(FALSE);
im_busy=0;
}

